#line 2 "lex.l"
/* This file is part of Mailfromd.
   Copyright (C) 2005-2018 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif



#line 25 "lex.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

/* %not-for-header */

/* %if-c-only */
/* %if-not-reentrant */

/* %endif */
/* %endif */
/* %ok-for-header */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* %if-c++-only */
/* %endif */

/* %if-c-only */
    
/* %endif */

/* %if-c-only */

/* %endif */

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
/* %if-c-only */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
/* %endif */

/* %if-tables-serialization */
/* %endif */
/* end standard C headers. */

/* %if-c-or-c++ */
/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! FLEXINT_H */

/* %endif */

/* %if-c++-only */
/* %endif */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* %not-for-header */

/* Returned upon end-of-file. */
#define YY_NULL 0
/* %ok-for-header */

/* %not-for-header */

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)
/* %ok-for-header */

/* %if-reentrant */
/* %endif */

/* %if-not-reentrant */

/* %endif */

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE 16384
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

/* %if-not-reentrant */
extern int yyleng;
/* %endif */

/* %if-c-only */
/* %if-not-reentrant */
extern FILE *yyin, *yyout;
/* %endif */
/* %endif */

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
/* %if-c-only */
	FILE *yy_input_file;
/* %endif */

/* %if-c++-only */
/* %endif */

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* %if-c-only Standard (non-C++) definition */
/* %not-for-header */

/* %if-not-reentrant */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */
/* %endif */
/* %ok-for-header */

/* %endif */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* %if-c-only Standard (non-C++) definition */

/* %if-not-reentrant */
/* %not-for-header */

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;
/* %ok-for-header */

/* %endif */

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

/* %endif */

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* %% [1.0] yytext/yyin/yyout/yy_state_type/yylineno etc. def's & init go here */
/* Begin user sect3 */

#define FLEX_DEBUG

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

/* %if-c-only Standard (non-C++) definition */

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* %endif */

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
/* %% [2.0] code to fiddle yytext and yyleng for yymore() goes here \ */\
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
/* %% [3.0] code to copy yytext_ptr to yytext[] goes here, if %array \ */\
	(yy_c_buf_p) = yy_cp;

/* %% [4.0] data tables for the DFA and the user's section 1 definitions go here */
#define YY_NUM_RULES 151
#define YY_END_OF_BUFFER 152
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[985] =
    {   0,
        0,    0,    2,    2,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,  152,  150,
      134,  135,  150,  150,   16,  150,  150,  142,  150,  150,
      150,  103,  103,  138,  136,  140,  104,  150,  144,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  143,  145,  134,
       16,    2,    4,    3,    2,    2,  151,  151,  116,  130,
      130,  151,  149,  132,  130,  130,  149,  151,  133,  151,
      149,  126,   20,   18,   19,   20,   17,  151,    8,  151,
      104,  104,  104,  134,   16,  134,  137,    0,  106,  108,

      108,   16,   15,   90,   94,   92,   95,    0,    0,    0,
        0,  105,    0,    1,  102,    0,  103,  146,  139,  136,
      141,  147,  104,   99,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,   34,  104,  104,
      104,   30,  104,  104,  104,  104,   29,  104,  104,  104,
      104,  104,  104,  104,  104,   33,   41,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  134,
        0,   16,   16,   16,   16,   16,   16,   16,    2,    3,
        3,    5,    2,    2,    2,    2,    0,  116,  117,  117,
       91,  129,   93,   96,    0,   88,   88,    0,  123,  115,

      123,  100,  123,    0,  132,  127,  131,    0,  133,  128,
        0,  126,   18,   17,    0,    8,    0,   83,  104,  104,
      134,    0,   16,  108,  114,  107,  114,  114,   92,   95,
        0,    0,    0,  148,  102,  101,    0,    0,    0,    0,
       99,  104,  104,  104,  104,  104,  104,  104,  104,  104,
       26,  104,   42,  104,  104,   78,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,   68,  104,   64,
      104,  104,  104,  104,  104,  104,    0,  104,   43,  104,
      104,  104,  104,  104,  104,  104,  104,  104,   46,  104,
      104,  104,  104,  104,   48,  104,  104,  104,    0,    0,

        0,    0,    0,    0,   16,   16,   16,   16,   16,   16,
       16,   16,    2,  115,   93,   96,    0,   88,   88,    0,
        0,  122,  121,  100,    0,    0,    7,  104,  104,    0,
      107,  113,  112,    0,    0,   97,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  101,    0,    0,    0,    0,
      124,    0,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,   54,  104,
      104,  104,  104,  104,  104,  104,   35,   49,   32,   31,
      104,   74,   52,  104,   62,  104,  104,    0,    0,    0,
       44,  104,   66,  104,   45,  104,  104,  104,  104,  104,

      104,  104,  104,  104,  104,  104,   40,  104,    0,    0,
        0,    0,    0,    0,   16,    6,   16,   16,   16,   16,
       16,    2,    0,   98,   88,   88,   88,   88,   88,   88,
       88,   88,    0,   89,    0,  120,  121,  119,   82,   81,
      111,  112,  110,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  104,   69,
       67,   65,   47,   60,  104,   79,  104,  104,  104,  104,
      104,  104,  104,    0,    0,  104,  104,  104,  104,  104,

      104,  104,  104,  104,  104,  104,   61,   70,   63,    0,
        0,    0,    0,    0,   16,   16,   16,   16,   16,   16,
        2,   88,   88,   88,   88,   88,   88,   88,   88,   88,
       88,   88,   88,    0,    0,    0,    0,    0,    0,    0,
        0,  121,  118,  112,  109,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,  125,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,   21,  104,  104,   28,
      104,  104,   73,  104,   77,    0,    0,   59,  104,   76,

       22,  104,  104,   50,   75,   58,   53,  104,    0,    0,
        0,    0,    0,    0,   16,    9,   16,   16,   16,   16,
       16,    2,   88,   88,   88,   88,   88,   88,   88,   88,
       88,   88,   88,   88,   88,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  104,  104,   80,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,   55,   25,  104,   36,
        0,    0,    0,   57,  104,   27,   72,   51,    0,   56,

      104,    0,    9,    0,    0,    0,    0,    0,   16,   16,
       16,   10,   16,    2,   10,    0,   88,   88,   88,   88,
       88,   88,   88,   88,   88,   88,   88,   88,   88,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   84,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,   80,  104,  104,
      104,  104,  104,  104,  104,  104,  104,   24,  104,    0,
        0,   71,   23,    0,    0,    0,   16,   12,   16,   16,
       88,   88,   85,   88,   88,   88,   88,   88,   88,   88,

       88,   88,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,   84,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  104,  104,  104,
      104,  104,  104,   37,    0,    0,    0,   12,    0,    0,
       16,   16,   16,   11,   85,   88,   88,   88,   88,   88,
       88,   88,   88,   88,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   86,    0,    0,    0,    0,    0,
        0,    0,    0,  104,  104,  104,  104,  104,    0,   38,

        0,    0,    0,   11,   16,   14,   16,   88,   88,   88,
       88,   88,   88,    0,    0,   87,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  104,  104,    0,    0,   14,
        0,   16,   88,   88,   88,   88,   88,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       39,    0,   16,   88,   88,    0,    0,    0,    0,    0,
        0,    0,    0,   16,    0,    0,    0,   16,    0,   16,
       13,    0,   13,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
        1,   13,    1,    1,   14,   15,   16,   17,   18,   18,
       18,   18,   18,   18,   18,   19,   19,    1,    1,   20,
       21,   22,    1,    1,   23,   23,   23,   23,   23,   23,
       24,   24,   24,   24,   24,   24,   24,   24,   24,   24,
       24,   24,   24,   24,   24,   24,   24,   25,   24,   24,
        1,   26,    1,   27,   28,    1,   29,   30,   31,   32,

       33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
       43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
       53,   24,   54,   55,   56,   57,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[58] =
    {   0,
        1,    1,    2,    1,    1,    1,    3,    4,    5,    1,
        6,    7,    8,    9,    1,    1,   10,   11,   11,    1,
        1,    1,   12,   13,   13,   14,    1,   13,   12,   12,
       12,   12,   12,   12,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   15,    1,   16,    1
    } ;

static yyconst flex_int16_t yy_base[1044] =
    {   0,
        0,   56,   56,   63,   65,   69,   76,   78,   80,   89,
     2202, 2201,  115,    0, 2200,   59,   64,  171, 2202, 2206,
       92, 2206, 2180,  168, 2197,  172,  152, 2206, 2188, 2183,
     2184,  164,   92,   92, 2175,  164,    0,  174, 2206, 2167,
      170,  150,  166,  180,   59,  182,   73, 2151,  175,  165,
      187,  191, 2160,  188,  199, 2163, 2155, 2206, 2206,  239,
      245,    0, 2206,  238,  251,  240,  251, 2206, 2206,  254,
      243,  273,  278, 2181,  276,  247,  248,  290, 2206,  251,
     2186, 2206, 2206,  101, 2206, 2175,    0, 2184, 2206,  227,
      275, 2143,  280,  317,  329,  195, 2206,  329, 2206, 2206,

      293, 2182, 2206, 2206, 2206,  294,    0,    0, 2156, 2155,
     2171, 2206, 2166, 2206,  310,    0,  322,  332, 2206, 2206,
     2206, 2206,    0,  332,  335, 2149, 2147, 2141, 2145, 2141,
     2142, 2141,  305, 2131, 2132,  280, 2124, 2128, 2133,  307,
     2136,    0, 2126, 2120, 2122, 2122,    0, 2119, 2119, 2113,
     2128,  355, 2107, 2110, 2116,    0,    0, 2109,  328, 2125,
      336, 2106,  159, 2116, 2111, 2105, 2097, 2105,  323,  361,
      384,  427,  374,  389,  369,  276,  299,  380,    0,  381,
      382, 2206,  397,  385,  407, 2111,  410, 2206, 2206, 2144,
     2206, 2206,  395,    0,    0,    0, 2118, 2117,  414,  424,

      426,  420,  433,  446, 2135, 2206, 2206,  448, 2206, 2206,
     2140, 2206,  459,    0, 2139, 2206,  466,    0, 2094, 2100,
      471,  475,  478, 2136,  457,  476,  481,  478,  499,    0,
     2082,  489, 2109, 2206,  474,    0,    0,  499,  539,  586,
      509, 2103,  439, 2098, 2097,  477,  259, 2085, 2099, 2098,
        0, 2101,    0, 2092, 2099,    0, 2094, 2095,  453, 2092,
     2095, 2090, 2091, 2088, 2077, 2085, 2085,    0, 2088,    0,
     2075, 2084, 2071, 2069, 2081, 2062,  597, 2062,    0, 2079,
     2061, 2076, 2071, 2065, 2071, 2063, 2053, 2052,    0, 2052,
     2062, 2050, 2053, 2053,    0, 2047, 2052, 2053,  600,  603,

     2046, 2049, 2053, 2043,  595, 2085,  611,  606,  402,  506,
      492,  424, 2045, 2206,  609,    0, 2030,    0,  607, 2029,
      578, 2206,  641,  643,    0,  661, 2206, 2036, 2043,  651,
     2206, 2206,  663,    0, 2026, 2206, 2048,  619, 2043, 2042,
      648,  600, 2030, 2044,  658,    0, 2065,  668, 2072,  671,
     2206,    0, 2040, 2033, 2030, 2023, 2028, 2031, 2026, 2035,
      604, 2033, 2036, 2018, 2019, 2015, 2019, 2021,    0, 2023,
     2010, 2020, 2004, 2006, 2006, 2024,    0,    0,    0,    0,
     2004,    0,    0, 2005,    0, 2014, 2009,  699, 2006, 2018,
        0, 2013,    0, 2008,    0, 2007, 2012, 2013, 2004, 1994,

     2002, 1996, 2006, 2002, 1984, 1988,    0, 2000,  705,  702,
     1986, 2000, 1988, 2000, 2025, 2206,  529,  600,  673,  633,
      361, 1994, 1970, 2206, 1992,  663, 1987, 1986,  681,  668,
     1974, 1988, 1964, 2206,  709, 2206,  708,  719,    0,    0,
     2206,  721,  728, 1985, 1978, 1975, 1968, 1973, 1976, 1971,
     1980,  684, 1978, 1981, 1963, 1975,  686, 1970, 1969,  723,
      702, 1957, 1971,  759, 1992,  639, 1969, 1970, 1972, 1966,
     1955, 1954, 1947, 1956, 1963, 1949, 1944, 1944, 1942,    0,
        0,    0,    0,    0, 1947,    0, 1948, 1954, 1940, 1954,
     1936, 1950, 1949, 1940, 1932, 1933, 1935, 1946, 1928, 1944,

     1928, 1931, 1941, 1936, 1934, 1940,    0,    0,    0, 1962,
     1924, 1926, 1932, 1929,  752,  761,  459,  629,  766,  417,
      769, 1929, 1922, 1919, 1912, 1917, 1920, 1915, 1924,  726,
     1922, 1925, 1907,  739,  738,  740,  741,  747,  752,  732,
      746,  774, 2206,  783, 2206,  742, 1919, 1920, 1922, 1916,
     1905, 1904, 1897, 1906, 1913, 1899, 1894, 1894, 1906, 1899,
     1896, 1889, 1894, 1897, 1892, 1901,  762, 1899, 1902, 1884,
     1926,  802, 2206, 1882, 1899, 1878, 1897, 1896, 1877, 1876,
     1881, 1891, 1883, 1872, 1884, 1879,    0, 1866, 1866,    0,
     1881, 1876,    0, 1864,    0, 1881, 1878,  809, 1859,    0,

        0, 1874, 1873, 1858,    0,  810,    0, 1867, 1897,  812,
     1856, 1852,  797, 1859,  813, 2206,  814,  821,  613, 1896,
      693,  397,  782, 1865, 1866, 1868, 1862, 1851, 1850, 1843,
     1852, 1859, 1845, 1840, 1840,  751,  182,  785,  780,  788,
      793,  790,  801,  803,  802,  808,  792, 1840, 1857, 1836,
     1855, 1854, 1835, 1834, 1839, 1849, 1841, 1830, 1842, 1837,
      795, 1840, 1841, 1843, 1837, 1826, 1825, 1818, 1827, 1834,
     1820, 1815, 1815, 1833, 1823,    0, 1831, 1830, 1829, 1823,
     1820, 1826, 1810, 1820, 1808, 1817,    0,    0, 1816,    0,
     1800, 1811,  841, 2206, 1799,    0,    0,    0,  848, 2206,

     1805,  859, 2206,  860,  852, 1812, 1840, 1813, 1838,  837,
     1837, 2206,  865,  858, 2206, 1836, 1792, 1809, 1788, 1807,
     1806, 1787, 1786, 1791, 1801, 1793, 1782, 1794, 1789,  828,
      822,  842,  846,  843,  834,  836,  482,  841,  850,  838,
      835,  695, 1797, 1787, 2206, 1795, 1794, 1793, 1787, 1784,
     1790, 1774, 1784, 1772, 1768, 1785, 1764, 1783, 1782, 1763,
     1762, 1767, 1777, 1769, 1758, 1770, 1765,    0, 1758, 1772,
     1771, 1770, 1764, 1768, 1764, 1757, 1751,    0, 1745, 1760,
     1757,    0,    0, 1786, 1755,  883, 1784, 2206,  901, 1783,
     1757, 1747,    0, 1755, 1754, 1753, 1747, 1744, 1750, 1734,

     1744, 1732,  840,  860,  845,  861,  867,  854,  862,  869,
      878,  875,  866,  880,  877, 2206, 1731, 1745, 1744, 1743,
     1737, 1741, 1737, 1730, 1724, 1737, 1505, 1432, 1459, 1458,
     1449, 1443, 1435, 1441, 1401, 1411, 1394, 1391, 1404, 1403,
     1402, 1380, 1394,    0, 1385, 1373, 1416, 2206,  917, 1402,
     1401,  912, 1399, 2206,    0, 1358, 1359, 1263, 1260, 1254,
     1258, 1254, 1247, 1241,  892,  887, 1224,  898,  900,  902,
      894,   26,  904,  895,  903,  896, 1234, 1247, 1246, 1245,
     1226, 1243, 1198, 1195, 2206, 1200, 1194, 1174, 1166, 1167,
     1163, 1156, 1149, 1162, 1161, 1129, 1030, 1029, 1023, 2206,

     1047, 1002, 1037, 2206,  271, 2206,  934,  300,  602,  659,
      718,  801,  912,  885,  901, 2206,  914,  918,  919,  916,
      925,  930,  926,  922,  934,  937,  938,  939,  940,  927,
      943,  945,  949,  933,  952,  955,  956,  938,  984, 2206,
      946,  986,  962,  963,  964,  965,  966,  953,  968,  969,
      970,  954,  971,  973,  974,  975,  976,  977,  978,  979,
     2206,  977, 1008,  984,  985,  986,  987,  988,  990,  991,
      992,  993,  989, 1026,  995, 1003, 1030, 1030, 1032, 1033,
     2206, 1034, 2206, 2206, 1059, 1075, 1091, 1107, 1123, 1139,
     1155, 1171, 1185, 1200, 1207, 1220, 1236, 1252, 1266, 1277,

     1292, 1308, 1324, 1340, 1347, 1360, 1376, 1383, 1026, 1387,
     1394, 1399, 1036, 1403, 1040, 1413, 1424, 1429, 1436, 1042,
     1448, 1455, 1462, 1469, 1472, 1479, 1492, 1508, 1524, 1540,
     1556, 1572, 1588, 1604, 1620, 1636, 1652, 1668, 1684, 1700,
     1716, 1732, 1748
    } ;

static yyconst flex_int16_t yy_def[1044] =
    {   0,
      984,    1,  985,  985,  986,  986,  987,  987,  988,  988,
      989,  989,  984,   13,  990,  990,    1,    1,  984,  984,
      984,  984,  984,  991,  992,  993,  984,  984,  994,  984,
      984,  984,  984,  984,  984,  984,  995,  984,  984,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  984,  984,  984,
      992,  996,  984,  997,  996,  996,  998,  984,  984,  999,
     1000, 1001, 1002,  984,  999, 1000, 1001, 1003,  984, 1001,
     1004,  984,  984,  984,  984,  984, 1005, 1006,  984, 1006,
      995,  995,  995,  984,  992,  984,  984,  991,  984,  984,

     1007,  992,  984,  984,  984,  984, 1008, 1009,  984,  984,
      994,  984,  984,  984,  984, 1010,  984, 1011,  984,  984,
      984,  984,  995,  984,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  984,
      984,  992,  992,  992,  992,  992,  992,  992,  996,  997,
      997,  984,  996,  996,  996,  996,  998,  984,  984,  984,
      984,  984,  984, 1012, 1013, 1014, 1014, 1015,  984,  984,

      984,  984, 1016, 1002,  984,  984,  984, 1003,  984,  984,
     1004,  984,  984, 1005, 1006,  984, 1006,  995,  995,  995,
      984,  984,  992,  984,  984,  984,  984, 1017,  984, 1008,
     1018,  984,  984,  984,  984, 1019, 1020, 1011,  984, 1011,
      984,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  984,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  984,  984,

      984,  984,  984,  984,  992, 1021,  992,  992,  992,  992,
      992,  992,  996,  984,  984, 1012, 1022, 1014, 1014, 1023,
     1023,  984,  984,  984, 1024, 1006,  984,  995,  995,  984,
      984,  984,  984, 1025, 1018,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984, 1019, 1026, 1011, 1027, 1027,
      984,  239,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  984,  984,  984,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,

      995,  995,  995,  995,  995,  995,  995,  995,  984,  984,
      984,  984,  984,  984, 1021,  984, 1028,  992,  992,  992,
      992,  996, 1022,  984, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1023,  984, 1023,  984,  984,  984,  995,  995,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984, 1029, 1026,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  984,  984,  995,  995,  995,  995,  995,

      995,  995,  995,  995,  995,  995,  995,  995,  995, 1030,
      984,  984,  984,  984, 1028, 1031,  992,  992,  992,  992,
      996, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1023, 1023, 1023, 1023, 1023, 1023, 1023,
     1023,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
     1029, 1029,  984,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  984,  984,  995,  995,  995,

      995,  995,  995,  995,  995,  995,  995,  995, 1030, 1032,
      984,  984,  984,  984, 1031,  984, 1031,  992,  992, 1033,
      992, 1034, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1023, 1023, 1023, 1023, 1023,
     1023, 1023, 1023, 1023, 1023, 1023, 1023,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  995,  995,  995,  995,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  995,
      984,  984,  984,  984,  995,  995,  995,  995,  984,  984,

      995, 1032,  984, 1032,  984,  984, 1035,  984, 1036,  992,
     1033,  984,  992, 1034,  984, 1035, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1023,
     1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023,
     1023, 1023,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  995,  995,  995,
      995,  995,  995,  995,  995,  995,  995,  995,  995,  984,
      984,  995,  995, 1037,  984,  984, 1036,  984,  992, 1038,
     1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014, 1014,

     1014, 1014, 1023, 1023, 1023, 1023, 1023, 1023, 1023, 1023,
     1023, 1023, 1023, 1023, 1023,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  995,  995,  995,
      995,  995,  995,  995,  984,  984, 1037,  984,  984, 1039,
     1040,  992, 1038,  984, 1014, 1014, 1014, 1014, 1014, 1014,
     1014, 1014, 1014, 1014, 1023, 1023, 1023, 1023, 1023, 1023,
     1023, 1023, 1023, 1023, 1023, 1023,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  995,  995,  995,  995,  995,  984,  984,

     1041,  984, 1039,  984, 1040,  984,  992, 1014, 1014, 1014,
     1014, 1014, 1014, 1023, 1023,  984, 1023, 1023, 1023, 1023,
     1023, 1023, 1023, 1023,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  995,  995,  984, 1041,  984,
      984,  992, 1014, 1014, 1014, 1014, 1014, 1023, 1023, 1023,
     1023, 1023, 1023,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  992, 1014, 1014, 1023, 1023, 1023, 1023, 1023,
      984,  984,  984,  992, 1023, 1023,  984, 1042, 1043, 1042,
      984, 1043,  984,    0,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,

      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984
    } ;

static yyconst flex_int16_t yy_nxt[2264] =
    {   0,
       20,   21,   22,   21,   23,   24,   25,   26,   27,   28,
       29,   20,   20,   20,   30,   31,   32,   33,   33,   34,
       35,   36,   37,   37,   37,   38,   39,   40,   41,   42,
       43,   44,   45,   46,   37,   37,   47,   37,   37,   48,
       49,   50,   51,   52,   37,   53,   54,   55,   37,   56,
       57,   37,   37,   20,   58,   20,   59,   60,   63,   60,
      920,   89,   61,   90,   65,   63,   65,   68,   64,   66,
       69,   68,   70,   71,   69,   64,   70,   71,   74,   20,
       74,  434,   79,   75,   76,   75,   76,   70,   71,  139,
       72,   79,   91,   96,   72,   96,   70,   71,  140,   92,

      141,   77,  213,   77,  213,   80,  147,   93,  117,  117,
      117,  118,  119,  148,   80,   83,   84,   85,   84,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       86,   83,   83,   83,   83,   83,   83,   87,   87,   87,
       83,   83,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   83,   83,
       83,   83,   94,   99,   94,  100,  100,   95,  104,  109,
      115,  115,  130,  105,  121,  122,   20,  290,  116,  106,
      106,  124,  124,  101,  133,  131,   96,  153,   96,   91,

      126,  127,  132,  150,  291,  110,   92,  154,  134,  128,
      135,  129,  136,  155,   93,  116,  137,  151,  142,  158,
      162,  731,  138,  143,  144,  108,  152,  145,  156,  216,
      146,  165,  157,  217,  166,  163,  159,  434,  164,  160,
      170,  185,  170,  185,  167,  171,  172,  103,  172,  173,
      181,  192,  183,  182,  183,  984,  188,  184,  189,  189,
      191,  192,  174,  174,  201,  202,  202,  201,  202,  202,
      197,  193,  193,  906,  197,  200,  190,  175,  103,  186,
      205,  176,  191,  984,  177,  206,  206,  361,  178,  201,
      202,  202,  209,  193,  193,  226,  198,  210,  210,  203,

      198,  103,  203,  206,  362,  126,  127,  195,  158,  227,
      229,  229,  229,  261,  128,  210,  129,  310,  221,  262,
      221,  218,  220,  222,  203,  159,  235,  235,  160,  195,
      223,  103,  223,  173,   99,  311,  100,  100,  117,  117,
      117,  943,  237,  266,  228,  238,  174,  174,  241,  241,
      241,  257,  258,  267,  224,  297,  277,  240,  277,  298,
      282,  175,  170,  103,  170,  176,  242,  171,  243,  244,
      283,  103,  178,  285,  245,  246,  103,  305,  247,  286,
      287,  248,  103,  288,  249,  299,  185,  299,  185,  306,
      307,  103,  307,  984,  181,  520,  984,  182,  183,  715,

      183,  300,  300,  184,  103,  308,  308,  308,  185,  716,
      185,  315,  315,  315,  309,  188,  301,  189,  189,  103,
      302,  322,  322,  303,  186,  312,  103,  304,  172,  103,
      172,  322,  322,  322,  322,  190,  324,  324,  324,  322,
      322,  322,  323,  323,  174,  174,  186,  418,  205,  322,
      209,  322,  421,  206,  206,  210,  210,  621,  322,  175,
      213,  103,  213,  176,  332,  332,  177,  326,  327,  326,
      178,  206,  221,  210,  221,  354,  330,  222,  330,  223,
      103,  223,  332,  332,  332,  332,  332,  355,  332,  332,
      235,  235,  300,  300,  103,  174,  174,  333,  333,  371,

      372,  332,  348,  332,  618,  358,  332,  301,  103,  237,
      175,  302,  984,  359,  176,  229,  229,  229,  304,  360,
      337,  178,  338,  339,  240,  241,  241,  241,  340,  341,
      810,  103,  342,  420,  516,  343,  419,  434,  344,  349,
      350,  351,  350,  349,  349,  349,  349,  349,  349,  349,
      349,  349,  349,  349,  349,  352,  352,  352,  349,  349,
      349,  352,  352,  352,  349,  349,  352,  352,  352,  352,
      352,  352,  352,  352,  352,  352,  352,  352,  352,  352,
      352,  352,  352,  352,  352,  352,  352,  352,  352,  352,
      352,  352,  349,  349,  349,  349,  984,  103,  388,  984,

      388,  299,  103,  299,  409,  435,  409,  307,  103,  307,
      306,  984,  307,  103,  307,  103,  417,  300,  300,  410,
      410,  410,  308,  308,  308,  315,  315,  315,  452,  855,
      389,  103,  301,  434,  474,  103,  302,  390,  425,  303,
      426,  427,  517,  304,  710,  453,  428,  429,  436,  436,
      430,  475,  330,  431,  330,  445,  432,  437,  437,  324,
      324,  324,  326,  327,  326,  519,  436,  446,  300,  300,
      441,  441,  350,  351,  350,  103,  449,  619,  237,  442,
      442,  984,  574,  301,  450,  248,  944,  302,  441,  456,
      451,  457,  458,  240,  304,  103,  530,  459,  460,  523,

      388,  461,  388,  409,  462,  409,  409,  463,  409,  527,
      510,  524,  518,  531,  554,  436,  436,  528,  410,  410,
      410,  713,  560,  529,  542,  542,  543,  543,  441,  441,
      567,  555,  389,  436,  561,  545,  545,  544,  544,  390,
      534,  815,  535,  536,  543,  945,  441,  568,  537,  538,
      434,  564,  539,  545,  103,  540,  631,  516,  541,  565,
      572,  573,  572,  616,  434,  566,  617,  620,  103,  620,
      622,  636,  622,  632,  637,  641,  639,  640,  647,  646,
      644,  436,  436,  642,  730,  648,  638,  434,  343,  643,
      441,  441,  669,  434,  434,  434,  434,  645,  707,  436,

      707,  434,  434,  572,  573,  572,  434,  434,  441,  670,
      693,  699,  693,  699,  703,  616,  616,  704,  617,  617,
      694,  700,  709,  103,  709,  717,  732,  733,  431,  734,
      735,  736,  737,  738,  740,  434,  741,  742,  755,  103,
      434,  462,  693,  434,  693,  434,  946,  434,  434,  699,
      739,  699,  694,  784,  804,  784,  434,  434,  434,  700,
      715,  703,  703,  434,  704,  704,  790,  103,  790,  789,
      716,  803,  805,  806,  540,  807,  808,  434,  809,  811,
      812,  813,  814,  434,  850,  645,  850,  865,  867,  434,
      434,  434,  866,  434,  868,  434,  434,  434,  434,  869,

      434,  434,  851,  103,  851,  434,  872,  870,  871,  434,
      873,  874,  875,  876,  103,  434,  434,  434,  901,  914,
      901,  434,  434,  915,  434,  914,  919,  917,  852,  918,
      434,  921,  434,  434,  923,  434,  103,  922,  924,  947,
      916,  867,  434,  948,  902,  867,  949,  434,  950,  434,
      434,  434,  867,  434,  907,  434,  434,  434,  434,  434,
      951,  954,  952,  953,  745,  816,  955,  745,  956,  434,
      883,  434,  957,  434,  434,  942,  958,  434,  959,  960,
      434,  434,  768,  768,  961,  434,  940,  962,  103,  964,
      793,  855,  965,  793,  966,  914,  967,  968,  970,  969,

      816,  816,  971,  828,  883,  972,  828,  973,  434,  434,
      103,  855,  855,  975,  867,  914,  963,  976,  867,  883,
      883,  977,  914,  434,  434,  434,  434,  978,  103,  978,
      914,  979,  981,  979,  983,  981,  983,  231,  231,  904,
      974,  434,  434,  434,  941,  434,  434,  317,  317,  940,
      434,  320,  320,  347,  347,  938,  676,  937,  434,   62,
       62,   62,   62,   62,   62,   62,   62,   62,   62,   62,
       62,   62,   62,   62,   62,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   73,   73,   73,   73,   73,   73,   73,   73,   73,

       73,   73,   73,   73,   73,   73,   73,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   88,
       88,   88,   88,   88,   88,   88,   88,   88,   88,   88,
       88,   88,   88,   88,   88,   98,  768,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  107,  676,  936,
      935,  107,  934,  933,  828,  107,  107,  107,  932,  107,

      111,  931,  111,  111,  111,  111,  111,  111,  111,  111,
      111,  111,  111,  111,  111,  111,  123,  123,  123,  123,
      179,  828,  179,  179,  179,  179,  179,  828,  179,  179,
      179,  179,  179,  179,  179,  179,  180,  930,  180,  180,
      180,  180,  180,  180,  180,  180,  180,  180,  180,  180,
      180,  180,  187,  885,  187,  187,  187,  187,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  194,  194,
      929,  928,  927,  926,  816,  925,  194,  194,  194,  916,
      194,  196,  913,  912,  911,  793,  910,  909,  196,  196,
      793,  196,  199,  199,  199,  199,  199,  199,  199,  199,

      199,  199,  199,  199,  199,  199,  199,  199,  204,  204,
      204,  204,  204,  204,  204,  204,  204,  204,  204,  204,
      204,  204,  204,  204,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      211,  211,  211,  211,  211,  211,  211,  211,  211,  211,
      211,  211,  211,  211,  211,  211,  214,  214,  214,  214,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  225,  225,  225,  225,
      225,  225,  225,  225,  225,  225,  793,  225,  225,  225,
      225,  225,  230,  230,  230,  230,  236,  236,  236,  239,

      908,  854,  239,  906,  904,  239,  239,  239,  316,  316,
      316,  316,  318,  318,  318,  318,  325,  325,  848,  900,
      899,  898,  325,  325,  325,  897,  325,  334,  334,  896,
      895,  768,  894,  334,  334,  334,  893,  334,  335,  335,
      335,  335,  892,  891,  335,  346,  346,  346,  415,  415,
      415,  415,  415,  415,  415,  415,  415,  415,  415,  415,
      415,  415,  415,  415,  423,  423,  423,  423,  890,  889,
      423,  433,  433,  433,  433,  888,  887,  433,  438,  438,
      438,  443,  443,  443,  465,  886,  883,  885,  465,  465,
      465,  465,  349,  349,  349,  349,  349,  349,  349,  349,

      349,  349,  349,  349,  349,  349,  349,  349,  515,  515,
      515,  515,  515,  515,  515,  515,  515,  515,  515,  515,
      515,  515,  515,  515,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      609,  884,  609,  609,  609,  609,  609,  609,  609,  609,
      609,  609,  609,  609,  609,  609,  615,  615,  615,  615,
      615,  615,  615,  615,  615,  615,  615,  615,  615,  615,
      615,  615,  702,  702,  702,  702,  702,  702,  702,  702,
      702,  702,  702,  702,  702,  702,  702,  702,  711,  711,
      711,  711,  711,  711,  711,  711,  711,  711,  711,  711,

      711,  711,  711,  711,  714,  714,  714,  714,  714,  714,
      714,  714,  714,  714,  714,  714,  714,  714,  714,  714,
      716,  716,  716,  716,  716,  716,  716,  716,  716,  716,
      716,  716,  716,  716,  716,  716,  787,  787,  787,  787,
      787,  787,  787,  787,  787,  787,  787,  787,  787,  787,
      787,  787,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  847,  847,  847,  847,  847,  853,  853,
      853,  853,  853,  853,  853,  853,  853,  853,  853,  853,
      853,  853,  853,  853,  903,  903,  903,  903,  903,  903,
      903,  903,  903,  903,  903,  903,  903,  903,  903,  903,

      905,  905,  905,  905,  905,  905,  905,  905,  905,  905,
      905,  905,  905,  905,  905,  905,  939,  939,  939,  939,
      939,  939,  939,  939,  939,  939,  939,  939,  939,  939,
      939,  939,  980,  980,  980,  980,  980,  980,  980,  980,
      980,  980,  980,  980,  980,  980,  980,  980,  982,  982,
      982,  982,  982,  982,  982,  982,  982,  982,  982,  982,
      982,  982,  982,  982,  883,  882,  881,  880,  745,  879,
      878,  745,  745,  877,  864,  863,  862,  861,  860,  859,
      858,  857,  855,  856,  855,  854,  788,  849,  848,  846,
      845,  844,  843,  842,  841,  676,  840,  839,  676,  676,

      838,  837,  836,  835,  834,  833,  832,  831,  830,  829,
      828,  827,  826,  568,  825,  824,  823,  822,  821,  820,
      819,  818,  816,  817,  816,  802,  801,  800,  799,  798,
      797,  796,  795,  794,  793,  792,  791,  531,  715,  712,
      788,  786,  715,  785,  783,  782,  781,  780,  779,  778,
      777,  776,  775,  774,  773,  772,  771,  770,  768,  769,
      768,  767,  766,  765,  764,  763,  762,  761,  760,  759,
      758,  757,  756,  754,  753,  752,  751,  750,  749,  748,
      747,  746,  745,  744,  743,  453,  729,  728,  727,  726,
      725,  724,  723,  722,  721,  720,  719,  718,  712,  708,

      706,  705,  610,  701,  698,  697,  696,  695,  692,  691,
      690,  689,  688,  687,  686,  685,  684,  683,  682,  681,
      680,  679,  678,  677,  676,  675,  674,  362,  573,  673,
      672,  671,  668,  667,  666,  665,  664,  663,  662,  661,
      660,  659,  658,  657,  656,  655,  654,  653,  652,  651,
      650,  649,  635,  634,  633,  630,  629,  628,  627,  626,
      625,  624,  623,  614,  613,  612,  611,  610,  608,  607,
      606,  605,  604,  603,  602,  601,  600,  599,  598,  597,
      596,  595,  594,  593,  592,  591,  590,  589,  588,  587,
      586,  585,  584,  583,  582,  581,  580,  579,  578,  577,

      576,  575,  464,  570,  569,  563,  562,  559,  558,  557,
      556,  553,  552,  551,  550,  549,  548,  547,  546,  434,
      533,  532,  526,  525,  522,  424,  521,  416,  514,  513,
      512,  511,  509,  508,  507,  506,  505,  504,  503,  502,
      501,  500,  499,  498,  497,  496,  495,  494,  493,  492,
      491,  490,  489,  488,  487,  486,  485,  484,  483,  482,
      481,  480,  479,  478,  477,  476,  473,  472,  471,  470,
      469,  468,  467,  466,  351,  464,  455,  454,  448,  447,
      444,  336,  440,  439,  434,  424,  422,  416,  414,  413,
      412,  411,  408,  407,  406,  405,  404,  403,  402,  401,

      400,  399,  398,  397,  396,  395,  394,  393,  392,  391,
      387,  386,  385,  384,  383,  382,  381,  380,  379,  378,
      377,  376,  375,  374,  373,  370,  369,  368,  367,  366,
      365,  364,  363,  357,  356,  353,  345,  336,  331,  329,
      328,  216,  212,  207,  321,  319,  314,  313,  296,  295,
      294,  293,  292,  289,  284,  281,  280,  279,  278,  276,
      275,  274,  273,  272,  271,  270,  269,  268,  265,  264,
      263,  260,  259,  256,  255,  254,  253,  252,  251,  250,
      234,  112,  233,  232,  103,  219,  216,  114,  212,  207,
      169,  168,  161,  149,  125,  120,  114,  113,  112,  103,

       97,  984,   89,   82,   82,   19,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984
    } ;

static yyconst flex_int16_t yy_chk[2264] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    2,    3,    2,
      872,   16,    2,   16,    4,    4,    4,    5,    3,    4,
        5,    6,    5,    5,    6,    4,    6,    6,    7,   17,
        8,  872,    9,    7,    7,    8,    8,    9,    9,   45,
        5,   10,   17,   21,    6,   21,   10,   10,   45,   17,

       45,    7,   84,    8,   84,    9,   47,   17,   33,   33,
       33,   34,   34,   47,   10,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   18,   24,   18,   24,   24,   18,   26,   27,
       32,   32,   42,   26,   36,   36,   18,  163,   32,   26,
       26,   38,   38,   24,   43,   42,   96,   50,   96,   18,

       41,   41,   42,   49,  163,   27,   18,   50,   43,   41,
       44,   41,   44,   50,   18,   32,   44,   49,   46,   52,
       54,  637,   44,   46,   46,   26,   49,   46,   51,   90,
       46,   55,   51,   90,   55,   54,   52,  637,   54,   52,
       60,   66,   60,   66,   55,   60,   61,   61,   61,   61,
       64,   71,   65,   64,   65,   76,   67,   65,   67,   67,
       70,   70,   61,   61,   77,   77,   77,   80,   80,   80,
       71,   70,   70,  905,   76,   72,   67,   61,  176,   66,
       73,   61,   75,   75,   61,   73,   73,  247,   61,   72,
       72,   72,   78,   75,   75,  101,   71,   78,   78,   77,

       76,  177,   80,   73,  247,   91,   91,   70,   93,  101,
      106,  106,  106,  136,   91,   78,   91,  176,   94,  136,
       94,   91,   93,   94,   72,   93,  115,  115,   93,   75,
       95,   95,   95,   95,   98,  177,   98,   98,  117,  117,
      117,  908,  118,  140,  101,  118,   95,   95,  124,  124,
      124,  133,  133,  140,   98,  169,  152,  118,  152,  169,
      159,   95,  170,  421,  170,   95,  125,  170,  125,  125,
      159,  175,   95,  161,  125,  125,  173,  173,  125,  161,
      161,  125,  178,  161,  125,  171,  184,  171,  184,  173,
      174,  174,  174,  180,  181,  421,  180,  181,  183,  622,

      183,  171,  171,  183,  309,  174,  174,  174,  185,  622,
      185,  193,  193,  193,  175,  187,  171,  187,  187,  520,
      171,  199,  199,  171,  184,  178,  312,  171,  172,  172,
      172,  200,  200,  201,  201,  187,  202,  202,  202,  199,
      203,  203,  201,  201,  172,  172,  185,  309,  204,  200,
      208,  201,  312,  204,  204,  208,  208,  520,  203,  172,
      213,  517,  213,  172,  225,  225,  172,  217,  217,  217,
      172,  204,  221,  208,  221,  243,  222,  221,  222,  223,
      223,  223,  225,  226,  226,  228,  228,  243,  227,  227,
      235,  235,  222,  222,  311,  223,  223,  227,  227,  259,

      259,  226,  238,  228,  517,  246,  227,  222,  310,  238,
      223,  222,  238,  246,  223,  229,  229,  229,  222,  246,
      232,  223,  232,  232,  238,  241,  241,  241,  232,  232,
      737,  417,  232,  311,  417,  232,  310,  737,  232,  239,
      239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
      239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
      239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
      239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
      239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
      239,  239,  239,  239,  239,  239,  240,  305,  277,  240,

      277,  299,  418,  299,  300,  321,  300,  308,  308,  308,
      305,  240,  307,  307,  307,  619,  307,  299,  299,  300,
      300,  300,  308,  308,  308,  315,  315,  315,  342,  909,
      277,  518,  299,  321,  361,  420,  299,  277,  319,  299,
      319,  319,  418,  299,  619,  342,  319,  319,  323,  323,
      319,  361,  330,  319,  330,  338,  319,  323,  323,  324,
      324,  324,  326,  326,  326,  420,  323,  338,  330,  330,
      333,  333,  350,  350,  350,  419,  341,  518,  348,  333,
      333,  348,  466,  330,  341,  466,  910,  330,  333,  345,
      341,  345,  345,  348,  330,  621,  430,  345,  345,  426,

      388,  345,  388,  410,  345,  410,  409,  345,  409,  429,
      409,  426,  419,  430,  452,  437,  437,  429,  410,  410,
      410,  621,  457,  429,  437,  437,  438,  438,  442,  442,
      461,  452,  388,  437,  457,  443,  443,  442,  442,  388,
      435,  742,  435,  435,  438,  911,  442,  461,  435,  435,
      742,  460,  435,  443,  515,  435,  530,  515,  435,  460,
      464,  464,  464,  516,  435,  460,  516,  519,  519,  519,
      521,  534,  521,  530,  535,  538,  536,  537,  541,  540,
      539,  542,  542,  538,  636,  546,  535,  540,  546,  538,
      544,  544,  567,  535,  534,  536,  537,  539,  613,  542,

      613,  541,  538,  572,  572,  572,  636,  539,  544,  567,
      598,  606,  598,  606,  610,  615,  617,  610,  615,  617,
      598,  606,  618,  618,  618,  623,  638,  639,  623,  640,
      641,  642,  643,  644,  645,  639,  646,  647,  661,  710,
      638,  661,  693,  640,  693,  642,  912,  647,  641,  699,
      644,  699,  693,  705,  731,  705,  643,  645,  644,  699,
      714,  702,  704,  646,  702,  704,  713,  713,  713,  710,
      714,  730,  732,  733,  730,  734,  735,  731,  736,  738,
      739,  740,  741,  730,  786,  803,  786,  804,  806,  735,
      741,  736,  805,  740,  807,  803,  738,  732,  734,  808,

      805,  733,  789,  789,  789,  739,  811,  809,  810,  808,
      812,  813,  814,  815,  852,  804,  806,  809,  849,  865,
      849,  813,  807,  866,  810,  868,  871,  869,  789,  870,
      812,  873,  815,  811,  875,  814,  907,  874,  876,  913,
      914,  917,  866,  915,  849,  918,  919,  865,  920,  871,
      874,  876,  921,  868,  852,  869,  915,  870,  875,  873,
      922,  925,  923,  924,  926,  927,  928,  929,  930,  917,
      931,  920,  932,  918,  919,  907,  933,  924,  934,  935,
      921,  923,  936,  937,  938,  922,  939,  941,  942,  943,
      944,  945,  946,  947,  948,  949,  950,  951,  953,  952,

      954,  955,  956,  957,  958,  959,  960,  962,  948,  952,
      963,  964,  965,  966,  967,  968,  942,  969,  970,  971,
      972,  973,  975,  949,  950,  951,  953,  974,  974,  974,
      976,  977,  978,  977,  979,  980,  982, 1009, 1009,  903,
      963,  966,  967,  968,  902,  969,  970, 1013, 1013,  901,
      975, 1015, 1015, 1020, 1020,  899,  898,  897,  976,  985,
      985,  985,  985,  985,  985,  985,  985,  985,  985,  985,
      985,  985,  985,  985,  985,  986,  986,  986,  986,  986,
      986,  986,  986,  986,  986,  986,  986,  986,  986,  986,
      986,  987,  987,  987,  987,  987,  987,  987,  987,  987,

      987,  987,  987,  987,  987,  987,  987,  988,  988,  988,
      988,  988,  988,  988,  988,  988,  988,  988,  988,  988,
      988,  988,  988,  989,  989,  989,  989,  989,  989,  989,
      989,  989,  989,  989,  989,  989,  989,  989,  989,  990,
      990,  990,  990,  990,  990,  990,  990,  990,  990,  990,
      990,  990,  990,  990,  990,  991,  896,  991,  991,  991,
      991,  991,  991,  991,  991,  991,  991,  991,  991,  991,
      991,  992,  992,  992,  992,  992,  992,  992,  992,  992,
      992,  992,  992,  992,  992,  992,  992,  993,  895,  894,
      893,  993,  892,  891,  890,  993,  993,  993,  889,  993,

      994,  888,  994,  994,  994,  994,  994,  994,  994,  994,
      994,  994,  994,  994,  994,  994,  995,  995,  995,  995,
      996,  887,  996,  996,  996,  996,  996,  886,  996,  996,
      996,  996,  996,  996,  996,  996,  997,  884,  997,  997,
      997,  997,  997,  997,  997,  997,  997,  997,  997,  997,
      997,  997,  998,  883,  998,  998,  998,  998,  998,  998,
      998,  998,  998,  998,  998,  998,  998,  998,  999,  999,
      882,  881,  880,  879,  878,  877,  999,  999,  999,  867,
      999, 1000,  864,  863,  862,  861,  860,  859, 1000, 1000,
      858, 1000, 1001, 1001, 1001, 1001, 1001, 1001, 1001, 1001,

     1001, 1001, 1001, 1001, 1001, 1001, 1001, 1001, 1002, 1002,
     1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002, 1002, 1002, 1002, 1003, 1003, 1003, 1003, 1003, 1003,
     1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003, 1003,
     1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004, 1004,
     1004, 1004, 1004, 1004, 1004, 1004, 1005, 1005, 1005, 1005,
     1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006, 1006,
     1006, 1006, 1006, 1006, 1006, 1006, 1007, 1007, 1007, 1007,
     1007, 1007, 1007, 1007, 1007, 1007,  857, 1007, 1007, 1007,
     1007, 1007, 1008, 1008, 1008, 1008, 1010, 1010, 1010, 1011,

      856,  853, 1011,  851,  850, 1011, 1011, 1011, 1012, 1012,
     1012, 1012, 1014, 1014, 1014, 1014, 1016, 1016,  847,  846,
      845,  843, 1016, 1016, 1016,  842, 1016, 1017, 1017,  841,
      840,  839,  838, 1017, 1017, 1017,  837, 1017, 1018, 1018,
     1018, 1018,  836,  835, 1018, 1019, 1019, 1019, 1021, 1021,
     1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021, 1021,
     1021, 1021, 1021, 1021, 1022, 1022, 1022, 1022,  834,  833,
     1022, 1023, 1023, 1023, 1023,  832,  831, 1023, 1024, 1024,
     1024, 1025, 1025, 1025, 1026,  830,  829,  828, 1026, 1026,
     1026, 1026, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027,

     1027, 1027, 1027, 1027, 1027, 1027, 1027, 1027, 1028, 1028,
     1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028, 1028,
     1028, 1028, 1028, 1028, 1029, 1029, 1029, 1029, 1029, 1029,
     1029, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 1029, 1029,
     1030,  827, 1030, 1030, 1030, 1030, 1030, 1030, 1030, 1030,
     1030, 1030, 1030, 1030, 1030, 1030, 1031, 1031, 1031, 1031,
     1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031, 1031,
     1031, 1031, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032,
     1032, 1032, 1032, 1032, 1032, 1032, 1032, 1032, 1033, 1033,
     1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033, 1033,

     1033, 1033, 1033, 1033, 1034, 1034, 1034, 1034, 1034, 1034,
     1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034, 1034,
     1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035, 1035,
     1035, 1035, 1035, 1035, 1035, 1035, 1036, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036, 1036,
     1036, 1036, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037,
     1037, 1037, 1037, 1037, 1037, 1037, 1037, 1037, 1038, 1038,
     1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038, 1038,
     1038, 1038, 1038, 1038, 1039, 1039, 1039, 1039, 1039, 1039,
     1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039, 1039,

     1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040, 1040,
     1040, 1040, 1040, 1040, 1040, 1040, 1041, 1041, 1041, 1041,
     1041, 1041, 1041, 1041, 1041, 1041, 1041, 1041, 1041, 1041,
     1041, 1041, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042,
     1042, 1042, 1042, 1042, 1042, 1042, 1042, 1042, 1043, 1043,
     1043, 1043, 1043, 1043, 1043, 1043, 1043, 1043, 1043, 1043,
     1043, 1043, 1043, 1043,  826,  825,  824,  823,  822,  821,
      820,  819,  818,  817,  802,  801,  800,  799,  798,  797,
      796,  795,  794,  792,  791,  790,  787,  785,  784,  781,
      780,  779,  777,  776,  775,  774,  773,  772,  771,  770,

      769,  767,  766,  765,  764,  763,  762,  761,  760,  759,
      758,  757,  756,  755,  754,  753,  752,  751,  750,  749,
      748,  747,  746,  744,  743,  729,  728,  727,  726,  725,
      724,  723,  722,  721,  720,  719,  718,  717,  716,  711,
      709,  708,  707,  706,  701,  695,  692,  691,  689,  686,
      685,  684,  683,  682,  681,  680,  679,  678,  677,  675,
      674,  673,  672,  671,  670,  669,  668,  667,  666,  665,
      664,  663,  662,  660,  659,  658,  657,  656,  655,  654,
      653,  652,  651,  650,  649,  648,  635,  634,  633,  632,
      631,  630,  629,  628,  627,  626,  625,  624,  620,  614,

      612,  611,  609,  608,  604,  603,  602,  599,  597,  596,
      594,  592,  591,  589,  588,  586,  585,  584,  583,  582,
      581,  580,  579,  578,  577,  576,  575,  574,  571,  570,
      569,  568,  566,  565,  564,  563,  562,  561,  560,  559,
      558,  557,  556,  555,  554,  553,  552,  551,  550,  549,
      548,  547,  533,  532,  531,  529,  528,  527,  526,  525,
      524,  523,  522,  514,  513,  512,  511,  510,  506,  505,
      504,  503,  502,  501,  500,  499,  498,  497,  496,  495,
      494,  493,  492,  491,  490,  489,  488,  487,  485,  479,
      478,  477,  476,  475,  474,  473,  472,  471,  470,  469,

      468,  467,  465,  463,  462,  459,  458,  456,  455,  454,
      453,  451,  450,  449,  448,  447,  446,  445,  444,  433,
      432,  431,  428,  427,  425,  423,  422,  415,  414,  413,
      412,  411,  408,  406,  405,  404,  403,  402,  401,  400,
      399,  398,  397,  396,  394,  392,  390,  389,  387,  386,
      384,  381,  376,  375,  374,  373,  372,  371,  370,  368,
      367,  366,  365,  364,  363,  362,  360,  359,  358,  357,
      356,  355,  354,  353,  349,  347,  344,  343,  340,  339,
      337,  335,  329,  328,  320,  317,  313,  306,  304,  303,
      302,  301,  298,  297,  296,  294,  293,  292,  291,  290,

      288,  287,  286,  285,  284,  283,  282,  281,  280,  278,
      276,  275,  274,  273,  272,  271,  269,  267,  266,  265,
      264,  263,  262,  261,  260,  258,  257,  255,  254,  252,
      250,  249,  248,  245,  244,  242,  233,  231,  224,  220,
      219,  215,  211,  205,  198,  197,  190,  186,  168,  167,
      166,  165,  164,  162,  160,  158,  155,  154,  153,  151,
      150,  149,  148,  146,  145,  144,  143,  141,  139,  138,
      137,  135,  134,  132,  131,  130,  129,  128,  127,  126,
      113,  111,  110,  109,  102,   92,   88,   86,   81,   74,
       57,   56,   53,   48,   40,   35,   31,   30,   29,   25,

       23,   19,   15,   12,   11,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984,  984,  984,  984,  984,  984,  984,  984,
      984,  984,  984
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 1;

static yyconst flex_int16_t yy_rule_linenum[151] =
    {   0,
      479,  480,  481,  482,  483,  485,  490,  491,  493,  509,
      514,  519,  523,  526,  530,  531,  533,  536,  537,  538,
      542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
      552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
      562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
      572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
      582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
      592,  593,  594,  595,  596,  597,  598,  634,  635,  637,
      638,  639,  640,  642,  645,  648,  651,  654,  658,  663,
      666,  669,  672,  675,  677,  689,  701,  703,  707,  710,

      714,  715,  716,  718,  755,  756,  757,  759,  761,  766,
      771,  776,  781,  786,  790,  791,  796,  801,  806,  809,
      814,  817,  822,  827,  828,  868,  890,  899,  904,  909,
      912,  933,  953,  969,  970,  971,  972,  973,  974,  975,
      976,  977,  978,  979,  980,  981,  982,  983,  984,  986
    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lex.l"

#line 26 "lex.l"
#include <sys/types.h>	
#include <sys/stat.h>
#include "mailfromd.h"
#include <mailutils/yyloc.h>
#include "gram.h"
#include "prog.h"
#include "srvcfg.h"

static mu_linetrack_t trk;

static struct mu_locus_point start_locus; /* Location when the last state switch
					    occurred */
static mu_opool_t string_pool;   /* Opool for constructing string values */
static char *multiline_delimiter; /* End of here-document delimiter */ 
static size_t multiline_delimiter_len; /* Length of multiline_delimiter_len */
static int multiline_unescape;         /* Unescape here-document contents */
static int (*char_to_strip)(char);     /* Strip matching characters of each
					  here-document line */
struct mu_locus_range const *
get_locus(void)
{
	return &yylloc;
}

static int
is_tab(char c)
{
	return c == '\t';
}
 
static int
is_space(char c)
{
	return c == '\t' || c == ' ';
}

static unsigned char
c_unescape(unsigned char inc)
{
	int outc = mu_wordsplit_c_unquote_char(inc);
        return outc ? outc : inc;
}

static void
switch_origin(struct mu_locus_point *pt)
{
	mu_linetrack_origin(trk, pt);
	mu_locus_point_deinit(pt);
}

#define line_begin string_begin
#define line_add string_add
#define line_add_char string_add_char
static void line_finish(void);
static void string(const char *str, size_t len);
static int isemptystr(char *text);
static int builtin_const(const char *s, size_t len);


/* Input context flags */
#define INCTX_MODULE     0x1  /* current input is a MFL module */
#define INCTX_HADINPUT   0x2  /* some statements has already been processed */
#define INCTX_IGNORE_BYE 0x4  /* ignore eventual `bye' statement, because
                                 this is an #included module */

/* Input context stack */
struct inctx {                     /* input context structure */
	struct inctx *parent;      /* parent context */
	struct mu_locus_range locus;/* locus where the context was pushed */
	mu_linetrack_t trk;
	struct input_file_ident id;/* file id structure to prevent recursion */
	FILE *file;                /* saved yyin */ 
	pid_t pp_pid;              /* preprocessor pid, if used */
	int inctx_flags;           /* input context flags */ 
	YY_BUFFER_STATE buf;       /* lex buffer state */
};

struct inctx *inctx_tos;           /* stack of input contexts */

/* Current input context: */
static pid_t pp_pid;               /* preprocessor pid */
static struct input_file_ident input_file_id;
static int inctx_flags;            /* input context flags */

/* If not 0, emit_token keeps a token that yylex must return on the
   next call. See YY_USER_ACTION below. */
static int emit_token;

/* Find on stack an input context that matches the given file id.
   Return pointer to the context. */
struct inctx *
inctx_locate(struct input_file_ident *id)
{
	struct inctx *ctx;

	for (ctx = inctx_tos; ctx; ctx = ctx->parent)
		if (ctx->id.device == id->device
		    && ctx->id.i_node == id->i_node)
			break;
	return ctx;
}
	
/* Push input context */	
static void
inctx_push()
{
	struct inctx *ctx = mu_alloc(sizeof(*ctx));

	mu_locus_range_init(&ctx->locus);
	mu_locus_range_copy(&ctx->locus, &yylloc);
	ctx->trk = trk;
	ctx->id = input_file_id;
	ctx->file = yyin;
	ctx->pp_pid = pp_pid;
	ctx->inctx_flags = inctx_flags;
	ctx->buf = YY_CURRENT_BUFFER;
	ctx->parent = inctx_tos;
	inctx_tos = ctx;
}

/* Pop input context from the top of the stack into the current
   input context. Return 1 if there are no more contexts left. */
int
inctx_pop()
{
	struct inctx *ctx = inctx_tos;
	
	if (!ctx)
		return 1;

	inctx_tos = ctx->parent;
	
	mu_locus_range_deinit(&ctx->locus);
	trk = ctx->trk;
	yyin = ctx->file; 
	input_file_id = ctx->id;
	inctx_flags = ctx->inctx_flags;
	yy_delete_buffer(YY_CURRENT_BUFFER);
	yy_switch_to_buffer(ctx->buf);
	pp_pid = ctx->pp_pid;
	free(ctx);
	return 0;
}

/* Setup the scanner for input from the file NAME. Return 0 on success,
   and an appropriate EX_ code on error. See lex_new_source below. */
static int
lex_new_source_0(const char *name)
{
	if (ext_pp) {
		yyin = pp_extrn_start(name, &pp_pid);
		if (!yyin) {
			parse_error(_("unable to start external "
				      "preprocessor `%s': %s"),
				     ext_pp,
				     mu_strerror(errno));
			return EX_OSFILE;
		}
	} else {
		yyin = fopen(name, "r");
		if (!yyin) {
			parse_error(_("cannot open %s: %s"), name,
				    mu_strerror(errno));
			return EX_NOINPUT;
		}
	}
	yy_switch_to_buffer(yy_create_buffer(yyin,YY_BUF_SIZE));
	MU_ASSERT (mu_linetrack_create (&trk, name, 2));
	return EX_OK;
}

/* Save the current input context on stack and set up the scanner for
   input from the file NAME. Return 0 on success,
   and an appropriate EX_ code on error. */
int
lex_new_source(const char *name, int flag)
{
	int rc;
	struct stat st;
	struct input_file_ident id;
	struct inctx *pctx;
	
	if (stat(name, &st)) {
		parse_error(_("cannot open `%s': %s"),
			    name, mu_strerror(errno));
		return EX_NOINPUT;
	} else if (!S_ISREG(st.st_mode)) {
		parse_error(_("`%s' is not a regular file"), name);
		return EX_NOINPUT;
	}
	
	id.device = st.st_dev;
	id.i_node = st.st_ino;
	
	pctx = inctx_locate(&id);
	if (pctx) {
		parse_error(_("recursive inclusion"));
		if (pctx->parent)
			parse_error_locus(&pctx->parent->locus,
					  _("`%s' already included here"),
					  name);
		else
			parse_error(_("`%s' already included at top level"),
				    name);
		return 1;
	}
	
	if (flag == LEX_ONCE && source_lookup(&id))
		return 0;

	if (yyin)
		inctx_push();
	rc = lex_new_source_0(name);
	if (rc)
		inctx_pop();
	else {
		input_file_id = id;
		if (flag == LEX_MODULE) {
			inctx_flags = INCTX_MODULE;
			emit_token = T_MODBEG;
		} else
			inctx_flags = 0;
	}
	return rc;
}


/* Return constant or variable token corresponding to the current
   value of yylval.literal->text. */
static int
variable_or_const()
{
	struct variable *vptr;
	const struct constant *cptr;

	cptr = constant_lookup(yylval.literal->text);
	if (cptr) {
		const struct value *value_ptr = &cptr->value;
		switch (value_ptr->type) {
		case dtype_number:
			yylval.number = value_ptr->v.number;
			return T_NUMBER;

		case dtype_string:
			yylval.literal = value_ptr->v.literal;
			return T_STRING;
			
		default:
			abort();
		}
	}

	vptr = variable_lookup(yylval.literal->text);
	if (!vptr) {
		parse_error(_("variable %s is not defined"),
			    yylval.literal->text);
		return T_BOGUS;
	}
	add_xref(vptr, &yylloc);
	yylval.var = vptr;
	return T_VARIABLE;
}
	
/* Saved lexer state before entering COMMENT */
static int save_state;
/* Same as BEGIN, but also saves the current locus. It is then used
   to report unclosed constructs at the end of file. */
#define BEGIN_X(s)							\
	do {								\
		BEGIN(s);						\
		mu_locus_point_copy (&start_locus, &yylloc.beg);	\
	} while(0)

/* If emit_token is not 0, push back current input and return the value
   of emit_token. Clear emit_token before returning. */
#define YY_USER_ACTION							\
	if (emit_token) {						\
		int tok = emit_token;					\
		emit_token = 0;						\
		if (yy_flex_debug)					\
			fprintf(stderr, "--emitting %d (module %s)\n",	\
				tok,top_module->name);			\
		mu_linetrack_retreat(trk, yyleng);			\
		yyless(0);						\
		return tok;						\
  	} else {							\
	        mu_linetrack_advance(trk, &yylloc, yytext, yyleng);	\
	        mu_stream_ioctl(mu_strerr, MU_IOCTL_LOGSTREAM,		\
			        MU_IOCTL_LOGSTREAM_SET_LOCUS_RANGE, &yylloc);\
   	}

/* Read next input chunk. */
#define YY_INPUT(buf,result,max_size)					\
	if (yyin == NULL)						\
		result = YY_NULL;					\
	else if (((result = fread(buf, 1, max_size, yyin)) == 0)	\
		 && ferror(yyin))					\
		YY_FATAL_ERROR("input in flex scanner failed");

/* Redeclare main entry point. Actual yylex is defined in the code section
   below. */
#define YY_DECL static int lexscan(void)


/* String composer */
static struct mu_locus_point string_beg;
static NODE *string_head, *string_tail;

static void
compose_add_node(NODE *node)
{
	if (string_tail)
		string_tail->next = node;
	else
		string_head = node;
	string_tail = node;
}

static void
compose_start(int state)
{
	if (string_head) {
		parse_error("INTERNAL ERROR: previous composition has not "
			    "finished when a new one started");
		abort();
	}
	mu_locus_point_copy(&string_beg, &yylloc.beg);
	BEGIN_X(state);
}

static int
compose_finish()
{
	if (string_tail != string_head) {
		while (string_head->next) {
			NODE *cat = alloc_node(node_type_concat,
					       &string_head->locus);
			NODE *next = string_head->next;
			cat->next = next->next;
			cat->v.concat.arg[0] = cast_to(dtype_string,
						       string_head);
			cat->v.concat.arg[1] = cast_to(dtype_string, next);
			string_head->next = next->next = NULL;
			string_head = cat;
		}
	}
	yylval.node = string_head;
	mu_locus_point_copy(&yylloc.beg, &string_beg);
	mu_locus_point_deinit(&string_beg);
	string_head = string_tail = NULL;
	return T_COMPOSE;
}

static void
compose_add_literal(struct literal *lit)
{
	NODE *node = alloc_node(node_type_string, &yylloc);
	node->v.literal = lit;
	compose_add_node(node);
	if (yy_flex_debug)
		fprintf(stderr, "--add literal: '%s'\n", lit->text);
}

static void
compose_add_string(const char *text, size_t length)
{
	compose_add_literal(string_alloc(text, length));
}

static void
compose_add_number(long num)
{
	NODE *node = alloc_node(node_type_number, &yylloc);
	node->v.number = num;
	compose_add_node(node);
}

void
compose_add_builtin_const(const char *s, size_t len)
{
	const char *sval;
	long nval;
	
	switch (builtin_const_value(s, len, &sval, &nval)) {
	case dtype_number:
		compose_add_number(nval);
		break;

	case dtype_string:
		compose_add_string(sval, strlen(sval));
		break;

	default:
		abort();
	}
}

void
compose_add_variable_or_const(int what)
{
	switch (what) {
	case T_NUMBER:
		compose_add_number(yylval.number);
		break;

	case T_STRING:
		compose_add_literal(yylval.literal);
		break;

	case T_VARIABLE:
		compose_add_node(create_node_variable(yylval.var, &yylloc));
	}
}

/* Exclusive states:

   SHELLMAGIC     Initial shell-magic boilerplate (#!... !#)
   COMMENT        Within a C-style comment;
   XIDENT         Expected identifier;
   STR            Processing a complex string;
   ML             Within a multi-line aggregator.  The line being built
                  requires stripping leading whitespace (if requested).
   CML            Continuation within a multi-line aggregator.  The line
                  being built does not require stripping leading whitespace.
   QML            Quoted multi-line aggregator.  No variable substitution and
                  unquoting is needed.

   Inclusive states:
   
   ONBLOCK	  Lexical tie-in after an `on' keyword.  In ONBLOCK state
                  the strigns `as', `host', `from', and `poll' are
		  recognized as keywords.  The string `for' also acquires
		  special meaning.
*/


#line 1848 "lex.c"

#define INITIAL 0
#define COMMENT 1
#define STR 2
#define ML 3
#define CML 4
#define QML 5
#define XIDENT 6
#define SHELLMAGIC 7
#define ONBLOCK 8

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
/* %if-c-only */
#include <unistd.h>
/* %endif */
/* %if-c++-only */
/* %endif */
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* %if-c-only Reentrant structure and macros (non-C++). */
/* %if-reentrant */
/* %if-c-only */

static int yy_init_globals (void );

/* %endif */
/* %if-reentrant */
/* %endif */
/* %endif End reentrant structures and macros. */

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* %if-bison-bridge */
/* %endif */

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

/* %not-for-header */

/* %ok-for-header */

/* %endif */

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT
/* %if-c-only Standard (non-C++) definition */
/* %not-for-header */

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif
/* %ok-for-header */

/* %endif */
#endif

/* %if-c-only */

/* %endif */

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* %if-c-only Standard (non-C++) definition */
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO fwrite( yytext, yyleng, 1, yyout )
/* %endif */
/* %if-c++-only C++ definition */
/* %endif */
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
/* %% [5.0] fread()/read() definition of YY_INPUT goes here unless we're doing C++ \ */\
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\
/* %if-c++-only C++ definition \ */\
/* %endif */

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
/* %if-c-only */
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
/* %endif */
/* %if-c++-only */
/* %endif */
#endif

/* %if-tables-serialization structures and prototypes */
/* %not-for-header */

/* %ok-for-header */

/* %not-for-header */

/* %tables-yydmap generated elements */
/* %endif */
/* end tables serialization structures and prototypes */

/* %ok-for-header */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1
/* %if-c-only Standard (non-C++) definition */

extern int yylex (void);

#define YY_DECL int yylex (void)
/* %endif */
/* %if-c++-only C++ definition */
/* %endif */
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

/* %% [6.0] YY_RULE_SETUP definition goes here */
#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/* %not-for-header */

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
/* %% [7.0] user's declarations go here */
#line 477 "lex.l"

         /* C-style comments */
#line 2102 "lex.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
/* %if-c-only */
			yyin = stdin;
/* %endif */
/* %if-c++-only */
/* %endif */

		if ( ! yyout )
/* %if-c-only */
			yyout = stdout;
/* %endif */
/* %if-c++-only */
/* %endif */

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
/* %% [8.0] yymore()-related code goes here */
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

/* %% [9.0] code to set up and find next match goes here */
		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 985 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 2206 );

yy_find_action:
/* %% [10.0] code to find the action number goes here */
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

/* %% [11.0] code for yylineno update goes here */

do_action:	/* This label is used only to access EOF actions. */

/* %% [12.0] debug code goes here */
		if ( yy_flex_debug )
			{
			if ( yy_act == 0 )
				fprintf( stderr, "--scanner backing up\n" );
			else if ( yy_act < 151 )
				fprintf( stderr, "--accepting rule at line %ld (\"%s\")\n",
				         (long)yy_rule_linenum[yy_act], yytext );
			else if ( yy_act == 151 )
				fprintf( stderr, "--accepting default rule (\"%s\")\n",
				         yytext );
			else if ( yy_act == 152 )
				fprintf( stderr, "--(end of buffer or a NUL)\n" );
			else
				fprintf( stderr, "--EOF (start condition %d)\n", YY_START );
			}

		switch ( yy_act )
	{ /* beginning of action switch */
/* %% [13.0] actions go here */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 479 "lex.l"
{ save_state = YYSTATE;  BEGIN_X(COMMENT); }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 480 "lex.l"
/* eat anything that's not a '*' */
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 481 "lex.l"
/* eat up '*'s not followed by '/'s */
	YY_BREAK
case 4:
/* rule 4 can match eol */
YY_RULE_SETUP
#line 482 "lex.l"
;
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 483 "lex.l"
BEGIN(save_state);
	YY_BREAK
/* Shell magic sequence */
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 485 "lex.l"
{
	if (yylloc.beg.mu_line == 1) {
		BEGIN_X(SHELLMAGIC);
	}
      }
	YY_BREAK
case 7:
/* rule 7 can match eol */
YY_RULE_SETUP
#line 490 "lex.l"
{ BEGIN(INITIAL); }
	YY_BREAK
case 8:
/* rule 8 can match eol */
YY_RULE_SETUP
#line 491 "lex.l"
;
	YY_BREAK
/* Configuration directives */
case 9:
/* rule 9 can match eol */
YY_RULE_SETUP
#line 493 "lex.l"
{
	struct mu_locus_point pt;
	if (parse_line_cpp(yytext, &pt) == 0)
		switch_origin(&pt);
}
	YY_BREAK
/* Normally, everything within a comment should be ignored, so
	   the exclusive condition for the rule below is an error.
	   Unfortunately, GNU m4 in versions up to 1.4.9 outputs line
	   synchronisation directives in comments, which makes any decent
	   compiler lost trace of which input line it is on.  To avoid
	   this, mfd handles #line directives even within a C-comment
	   block.

	   This bug was fixed in m4 version 1.4.10.  I prefer to keep
	   this kludge until I am pretty sure there are no 1.4.9 around.
	*/
case 10:
/* rule 10 can match eol */
YY_RULE_SETUP
#line 509 "lex.l"
{
	struct mu_locus_point pt;
	if (parse_line(yytext, &pt) == 0)
		switch_origin(&pt);
}
	YY_BREAK
case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 514 "lex.l"
{
	mu_linetrack_retreat(trk, 1);
	yyless(yyleng-1);
	parse_pragma(yytext);
}
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 519 "lex.l"
{
         yytext[yyleng-1] = 0; /* Kill trailing newline */
         parse_error("%s", yytext);
}
	YY_BREAK
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 523 "lex.l"
{
	parse_include(yytext, 1);
}
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 526 "lex.l"
{
	parse_include(yytext, 0);
}
	YY_BREAK
/* End-of-line comments */
case 15:
/* rule 15 can match eol */
YY_RULE_SETUP
#line 530 "lex.l"
;
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 531 "lex.l"
/* end-of-file comment */;
	YY_BREAK
/* expected identified (after 'require' or initial 'from') */
case 17:
YY_RULE_SETUP
#line 533 "lex.l"
{ BEGIN(INITIAL);
	          string(yytext, yyleng);
		  return T_IDENTIFIER; }
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 536 "lex.l"
;
	YY_BREAK
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 537 "lex.l"
;
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 538 "lex.l"
{ BEGIN(INITIAL);
	 mu_linetrack_retreat(trk, yyleng);
                  yyless(0); }
	YY_BREAK
/* Reserved words */
case 21:
YY_RULE_SETUP
#line 542 "lex.l"
return T_ACCEPT;
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 543 "lex.l"
return T_REJECT;
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 544 "lex.l"
return T_TEMPFAIL;
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 545 "lex.l"
return T_CONTINUE;
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 546 "lex.l"
return T_DISCARD;
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 547 "lex.l"
return T_ADD;
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 548 "lex.l"
return T_REPLACE;
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 549 "lex.l"
return T_DELETE;
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 550 "lex.l"
return T_IF;
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 551 "lex.l"
return T_FI;
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 552 "lex.l"
return T_ELSE;
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 553 "lex.l"
return T_ELIF;
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 554 "lex.l"
return T_ON;
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 555 "lex.l"
return T_DO;
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 556 "lex.l"
return T_DONE;
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 557 "lex.l"
return T_MATCHES;
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 558 "lex.l"
return T_FNMATCHES;
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 559 "lex.l"
return T_MXMATCHES;
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 560 "lex.l"
return T_MXFNMATCHES;
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 561 "lex.l"
return T_WHEN;
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 562 "lex.l"
return T_OR;
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 563 "lex.l"
return T_AND;
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 564 "lex.l"
return T_NOT;
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 565 "lex.l"
return T_NEXT;
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 566 "lex.l"
return T_PROG;
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 567 "lex.l"
return T_SET;
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 568 "lex.l"
return T_CATCH;
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 569 "lex.l"
return T_TRY;
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 570 "lex.l"
return T_ECHO;
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 571 "lex.l"
return T_RETURN;
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 572 "lex.l"
return T_RETURNS;
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 573 "lex.l"
return T_FUNC;
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 574 "lex.l"
return T_SWITCH;
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 575 "lex.l"
return T_CASE;
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 576 "lex.l"
return T_DEFAULT;
	YY_BREAK
case 56:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 6;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 577 "lex.l"
{ yylval.type = dtype_string; return T_TYPECAST; }
	YY_BREAK
case 57:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 6;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 578 "lex.l"
{ yylval.type = dtype_number; return T_TYPECAST; }
	YY_BREAK
case 58:
YY_RULE_SETUP
#line 579 "lex.l"
{ yylval.type = dtype_string; return T_TYPE; }
	YY_BREAK
case 59:
YY_RULE_SETUP
#line 580 "lex.l"
{ yylval.type = dtype_number; return T_TYPE; }
	YY_BREAK
case 60:
YY_RULE_SETUP
#line 581 "lex.l"
return T_CONST;
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 582 "lex.l"
return T_THROW;
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 583 "lex.l"
return T_LOOP;
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 584 "lex.l"
return T_WHILE;
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 585 "lex.l"
return T_FOR;
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 586 "lex.l"
return T_BREAK;
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 587 "lex.l"
return T_PASS;
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 588 "lex.l"
return T_BEGIN;
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 589 "lex.l"
return T_END;
	YY_BREAK
case 69:
YY_RULE_SETUP
#line 590 "lex.l"
return T_ALIAS;
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 591 "lex.l"
return T_VAPTR;
	YY_BREAK
case 71:
YY_RULE_SETUP
#line 592 "lex.l"
return T_PRECIOUS;
	YY_BREAK
case 72:
YY_RULE_SETUP
#line 593 "lex.l"
return T_REQUIRE;
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 594 "lex.l"
return T_IMPORT;
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 595 "lex.l"
return T_FROM;
	YY_BREAK
case 75:
YY_RULE_SETUP
#line 596 "lex.l"
return T_STATIC;
	YY_BREAK
case 76:
YY_RULE_SETUP
#line 597 "lex.l"
return T_PUBLIC;
	YY_BREAK
case 77:
YY_RULE_SETUP
#line 598 "lex.l"
{  if (inctx_tos && inctx_flags == 0) {
                int c;
		int flen;
		const char *fname = strrchr(yylloc.beg.mu_file, '/');

		if (fname)
			fname++;
		else
			fname = yylloc.beg.mu_file;
		flen = strlen(fname);
		
		if (flen > 3 && strcmp(fname + flen - 3, ".mf") == 0)
			flen -= 3;
		parse_warning_locus(&inctx_tos->locus,
				    _("including a module file is unreliable and may cause subtle errors"));
		/* TRANSLATORS: Do not translate `require %*.*s' */
		parse_warning_locus(&inctx_tos->locus,
				    _("use `require %*.*s' instead"),
				    flen, flen, fname);
		inctx_flags |= INCTX_IGNORE_BYE;
		mu_locus_point_copy(&start_locus, &yylloc.beg);
		while ((c = input()) != '.') {
		    if (c == 0) {
  		        mu_diag_at_locus_point(MU_DIAG_ERROR, &start_locus,
					       "%s",
					       _("unexpected end of file"));
		     	return 0;
		    } else {
			char ch = c;
			mu_linetrack_advance(trk, &yylloc, &ch, 1);
		    }
		}
	     } else if (inctx_flags & INCTX_HADINPUT) 
		     parse_error(_("misplaced `module'"));
	    return T_MODULE;
          }
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 634 "lex.l"
return T_BYE;
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 635 "lex.l"
return T_DCLEX;
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 637 "lex.l"
{ return builtin_const(yytext, yyleng); } 
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 638 "lex.l"
return T_POLL;
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 639 "lex.l"
return T_HOST;
	YY_BREAK
case 83:
YY_RULE_SETUP
#line 640 "lex.l"
return T_AS;
	YY_BREAK
/* Variables */
case 84:
YY_RULE_SETUP
#line 642 "lex.l"
{
	return builtin_const(yytext + 1, yyleng - 1);
}
	YY_BREAK
case 85:
YY_RULE_SETUP
#line 645 "lex.l"
{
	compose_add_builtin_const(yytext + 1, yyleng - 1);
}	
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 648 "lex.l"
{
	return builtin_const(yytext + 2, yyleng - 3);
}
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 651 "lex.l"
{
	compose_add_builtin_const(yytext + 2, yyleng - 3);
}
	YY_BREAK
case 88:
YY_RULE_SETUP
#line 654 "lex.l"
{
	string(yytext + 1, yyleng - 1);
	compose_add_variable_or_const(variable_or_const());
}
	YY_BREAK
case 89:
YY_RULE_SETUP
#line 658 "lex.l"
{
	string(yytext + 2, yyleng - 3);
	compose_add_variable_or_const(variable_or_const());
}
	YY_BREAK
/* Positional arguments */
case 90:
YY_RULE_SETUP
#line 663 "lex.l"
{
	return T_ARGCOUNT;
}
	YY_BREAK
case 91:
YY_RULE_SETUP
#line 666 "lex.l"
{
	compose_add_node(create_node_argcount(&yylloc));
}
	YY_BREAK
case 92:
YY_RULE_SETUP
#line 669 "lex.l"
{
	yylval.number = strtol(yytext + 1, NULL, 0);
	return T_ARG; }
	YY_BREAK
case 93:
YY_RULE_SETUP
#line 672 "lex.l"
{
	compose_add_node(create_node_arg(strtol(yytext + 1, NULL, 0), &yylloc));
}
	YY_BREAK
case 94:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 675 "lex.l"
{ return T_ARGX; }
	YY_BREAK
/* Sendmail variables */
case 95:
YY_RULE_SETUP
#line 677 "lex.l"
{
	        if (yyleng == 2)
	           string(yytext + 1, 1);
                else {
                   line_begin();
                   line_add("{", 1);
                   line_add(yytext + 1, yyleng - 1);
                   line_add("}", 1);
                   line_finish();
                }
                return T_SYMBOL;
              }
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 689 "lex.l"
{
	        if (yyleng == 2)
	           string(yytext + 1, 1);
                else {
                   line_begin();
                   line_add("{", 1);
                   line_add(yytext + 1, yyleng - 1);
                   line_add("}", 1);
                   line_finish();
                }
		compose_add_node(create_node_symbol(yylval.literal, &yylloc));
              }
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 701 "lex.l"
{
	string(yytext+1, yyleng - 1); return T_SYMBOL; }
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 703 "lex.l"
{
	string(yytext+1, yyleng - 1);
	compose_add_node(create_node_symbol(yylval.literal, &yylloc)); }
	YY_BREAK
/* Back-references */
case 99:
YY_RULE_SETUP
#line 707 "lex.l"
{
	 yylval.number = strtoul(yytext+1, NULL, 0);
	 return T_BACKREF; }
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 710 "lex.l"
{
	compose_add_node(create_node_backref(strtoul(yytext+1, NULL, 10),
					     &yylloc)); }
	YY_BREAK
/* Numeric strings */
case 101:
YY_RULE_SETUP
#line 714 "lex.l"
{ yylval.number = strtoul(yytext, NULL, 16); return T_NUMBER; };
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 715 "lex.l"
{ yylval.number = strtoul(yytext, NULL, 8); return T_NUMBER; };
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 716 "lex.l"
{ yylval.number = strtoul(yytext, NULL, 10); return T_NUMBER; };
	YY_BREAK
/* Identifiers */
case 104:
YY_RULE_SETUP
#line 718 "lex.l"
{
	const struct constant *cptr;

	cptr = constant_lookup(yytext);
	if (cptr) {
		const struct value *value_ptr = &cptr->value;
		switch (value_ptr->type) {
		case dtype_number:
			yylval.number = value_ptr->v.number;
			return T_NUMBER;

		case dtype_string:
			yylval.literal = value_ptr->v.literal;
			return T_STRING;
			
		default:
			abort();
		}
	}
	
	if (yylval.builtin = builtin_lookup(yytext))
		return T_BUILTIN;
	else if (yylval.function = function_lookup(yytext))
		return T_FUNCTION;
	else {
                struct variable *vptr;
		string(yytext, yyleng);
                vptr = variable_lookup(yylval.literal->text);
	        if (!vptr) {
			return T_IDENTIFIER;
		}
		add_xref(vptr, &yylloc);
		yylval.var = vptr;
		return T_VARIABLE;
	}
}
	YY_BREAK
/* Strings */
case 105:
YY_RULE_SETUP
#line 755 "lex.l"
{ string(yytext+1, yyleng-2); return T_STRING; }
	YY_BREAK
case 106:
YY_RULE_SETUP
#line 756 "lex.l"
{ string(yytext+1, yyleng-2); return T_STRING; }
	YY_BREAK
case 107:
/* rule 107 can match eol */
YY_RULE_SETUP
#line 757 "lex.l"
{ compose_start(STR);
                        compose_add_string(yytext + 1, yyleng - 3); }
	YY_BREAK
case 108:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 759 "lex.l"
{ compose_start(STR);
                        compose_add_string(yytext+1, yyleng-1); }
	YY_BREAK
case 109:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 5;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 761 "lex.l"
{
         compose_start(STR);
         line_add_char(strtoul(yytext + 3, NULL, 16));
         compose_add_literal(string_finish());
}
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 766 "lex.l"
{
         compose_start(STR);
         line_add_char(strtoul(yytext + 3, NULL, 16));
}
	YY_BREAK
case 111:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 771 "lex.l"
{
         compose_start(STR);
         line_add_char(strtoul(yytext + 3, NULL, 8));
         compose_add_literal(string_finish());
}
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 776 "lex.l"
{
         compose_start(STR);  
         line_add_char(strtoul(yytext + 3, NULL, 8));
}
	YY_BREAK
case 113:
/* rule 113 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 3;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 781 "lex.l"
{
         compose_start(STR);
         line_add_char(c_unescape(yytext[2]));
         compose_add_literal(string_finish());
}
	YY_BREAK
case 114:
/* rule 114 can match eol */
YY_RULE_SETUP
#line 786 "lex.l"
{
         compose_start(STR);
         line_add_char(c_unescape(yytext[2]));
}
	YY_BREAK
case 115:
/* rule 115 can match eol */
YY_RULE_SETUP
#line 790 "lex.l"
{ line_add(yytext, yyleng - 2); }
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 791 "lex.l"
{ BEGIN(INITIAL);
                        if (yyleng > 1)
                          line_add(yytext, yyleng - 1);
                        compose_add_literal(string_finish());
                        return compose_finish(); }
	YY_BREAK
case 117:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 796 "lex.l"
{
                       line_add(yytext, yyleng);
                       compose_add_literal(string_finish());
                       line_begin();
                 }
	YY_BREAK
case 118:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 4;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 801 "lex.l"
{
         line_add_char(strtoul(yytext + 2, NULL, 16));
         compose_add_literal(string_finish());       
         line_begin();
}
	YY_BREAK
case 119:
YY_RULE_SETUP
#line 806 "lex.l"
{
         line_add_char(strtoul(yytext + 2, NULL, 16));
}
	YY_BREAK
case 120:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 809 "lex.l"
{
         line_add_char(strtoul(yytext + 2, NULL, 8));
         compose_add_literal(string_finish());
         line_begin();
}
	YY_BREAK
case 121:
YY_RULE_SETUP
#line 814 "lex.l"
{
         line_add_char(strtoul(yytext + 2, NULL, 8));
}
	YY_BREAK
case 122:
/* rule 122 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp = yy_bp + 2;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 817 "lex.l"
{
         line_add_char(c_unescape(yytext[1]));
         compose_add_literal(string_finish());
         line_begin();
}
	YY_BREAK
case 123:
/* rule 123 can match eol */
YY_RULE_SETUP
#line 822 "lex.l"
{
         line_add_char(c_unescape(yytext[1]));
}
	YY_BREAK
/* Multi-line strings */
case 124:
/* rule 124 can match eol */
#line 828 "lex.l"
case 125:
/* rule 125 can match eol */
YY_RULE_SETUP
#line 828 "lex.l"
{
        char *p;

        char_to_strip = NULL;
        multiline_unescape = 1;

        line_begin();
        p = yytext + 2;
        if (*p == '-') {
            ++p;
            if (*p == ' ') {
                ++p;
                char_to_strip = is_space;
            } else
                char_to_strip = is_tab;
        }
        
        if (*p == '\\') {
            p++;
            multiline_unescape = 0;
        }
        if (*p == '\'') {
            char *q;
 
            p++;
            multiline_unescape = 0;
            q = strchr(p, '\'');
            multiline_delimiter_len = q - p;
        } else
            multiline_delimiter_len = strcspn(p, " \t");

        multiline_delimiter = mu_alloc(multiline_delimiter_len + 1);
        memcpy(multiline_delimiter, p, multiline_delimiter_len);
        multiline_delimiter[multiline_delimiter_len] = 0;
        if (multiline_unescape)
            compose_start(ML);
        else
            compose_start(QML);
}
	YY_BREAK
/* Quoted multilines */
case 126:
/* rule 126 can match eol */
YY_RULE_SETUP
#line 868 "lex.l"
{
        char *p;

        p = yytext;
        if (char_to_strip)
               for (; char_to_strip (*p); p++)
                      ;

        if (strlen(p) >= multiline_delimiter_len
            && memcmp(p, multiline_delimiter, multiline_delimiter_len) == 0
            && isemptystr(p + multiline_delimiter_len)) {
	       free (multiline_delimiter);
	       multiline_delimiter = NULL;
               multiline_delimiter_len = 0;
	       BEGIN(INITIAL);
               compose_add_literal(string_finish());
               return compose_finish();
        }
        line_add(p, strlen(p));
}
	YY_BREAK
/* Unquoted multilines */
case 127:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 890 "lex.l"
{
        char *p = yytext;
        if (char_to_strip)
               for (; char_to_strip (*p); p++)
                      ;
        line_add(p, strlen(p));
        compose_add_literal(string_finish());
        BEGIN_X(CML);
}
	YY_BREAK
case 128:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 899 "lex.l"
{
        line_add(yytext, yyleng);
        compose_add_literal(string_finish());
        line_begin();
}
	YY_BREAK
case 129:
YY_RULE_SETUP
#line 904 "lex.l"
{
        line_add(yytext, 1);
        compose_add_literal(string_finish());
        line_begin();
}
	YY_BREAK
case 130:
YY_RULE_SETUP
#line 909 "lex.l"
{
        line_add(yytext, yyleng);
}
	YY_BREAK
case 131:
/* rule 131 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 912 "lex.l"
{
        char *p;

        p = yytext;
        if (char_to_strip)
               for (; char_to_strip (*p); p++)
                      ;

        if (strlen(p) >= multiline_delimiter_len
            && memcmp(p, multiline_delimiter, multiline_delimiter_len) == 0
            && isemptystr(p + multiline_delimiter_len)) {
	       free (multiline_delimiter);
	       multiline_delimiter = NULL;
               multiline_delimiter_len = 0;
	       BEGIN(INITIAL);
               compose_add_literal(string_finish());
               return compose_finish();
        }
        line_add(p, strlen(p));
        compose_add_literal(string_finish());
}
	YY_BREAK
case 132:
/* rule 132 can match eol */
YY_RULE_SETUP
#line 933 "lex.l"
{
        char *p;

        p = yytext;
        if (char_to_strip)
               for (; char_to_strip (*p); p++)
                      ;

        if (strlen(p) >= multiline_delimiter_len
            && memcmp(p, multiline_delimiter, multiline_delimiter_len) == 0
            && isemptystr(p + multiline_delimiter_len)) {
	       free (multiline_delimiter);
	       multiline_delimiter = NULL;
               multiline_delimiter_len = 0;
	       BEGIN(INITIAL);
               compose_add_literal(string_finish());
               return compose_finish();
        }
        line_add(p, strlen(p));
}
	YY_BREAK
case 133:
/* rule 133 can match eol */
YY_RULE_SETUP
#line 953 "lex.l"
{
        if (yyleng >= multiline_delimiter_len
            && memcmp(yytext, multiline_delimiter,
                      multiline_delimiter_len) == 0
            && isemptystr(yytext + multiline_delimiter_len)) {
	       free (multiline_delimiter);
	       multiline_delimiter = NULL;
               multiline_delimiter_len = 0;
	       BEGIN(INITIAL);
               compose_add_literal(string_finish());
               return compose_finish();
        }
        line_add(yytext, yyleng);
        BEGIN_X(ML);
}
	YY_BREAK
/* Other tokens */
case 134:
YY_RULE_SETUP
#line 969 "lex.l"
;
	YY_BREAK
case 135:
/* rule 135 can match eol */
YY_RULE_SETUP
#line 970 "lex.l"
;
	YY_BREAK
case 136:
YY_RULE_SETUP
#line 971 "lex.l"
return T_EQ;
	YY_BREAK
case 137:
YY_RULE_SETUP
#line 972 "lex.l"
return T_NE;
	YY_BREAK
case 138:
YY_RULE_SETUP
#line 973 "lex.l"
return T_LT;
	YY_BREAK
case 139:
YY_RULE_SETUP
#line 974 "lex.l"
return T_LE;
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 975 "lex.l"
return T_GT;
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 976 "lex.l"
return T_GE;
	YY_BREAK
case 142:
YY_RULE_SETUP
#line 977 "lex.l"
return T_LOGAND;
	YY_BREAK
case 143:
YY_RULE_SETUP
#line 978 "lex.l"
return T_LOGOR;
	YY_BREAK
case 144:
YY_RULE_SETUP
#line 979 "lex.l"
return T_LOGXOR;
	YY_BREAK
case 145:
YY_RULE_SETUP
#line 980 "lex.l"
return T_LOGNOT;
	YY_BREAK
case 146:
YY_RULE_SETUP
#line 981 "lex.l"
return T_SHL;
	YY_BREAK
case 147:
YY_RULE_SETUP
#line 982 "lex.l"
return T_SHR;
	YY_BREAK
case 148:
YY_RULE_SETUP
#line 983 "lex.l"
return T_DOTS;
	YY_BREAK
case 149:
YY_RULE_SETUP
#line 984 "lex.l"
/* If a here-document is not closed and its next line does not
               end with a \n, prevent it from being displayed by ECHO */;
	YY_BREAK
case 150:
YY_RULE_SETUP
#line 986 "lex.l"
return yytext[0];
	YY_BREAK
case 151:
YY_RULE_SETUP
#line 987 "lex.l"
ECHO;
	YY_BREAK
#line 3389 "lex.c"
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(STR):
case YY_STATE_EOF(ML):
case YY_STATE_EOF(CML):
case YY_STATE_EOF(QML):
case YY_STATE_EOF(XIDENT):
case YY_STATE_EOF(SHELLMAGIC):
case YY_STATE_EOF(ONBLOCK):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
/* %% [14.0] code to do back-up for compressed tables and set up yy_cp goes here */
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */
/* %ok-for-header */

/* %if-c++-only */
/* %not-for-header */

/* %ok-for-header */

/* %endif */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
/* %if-c-only */
static int yy_get_next_buffer (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

/* %if-c-only */
/* %not-for-header */

    static yy_state_type yy_get_previous_state (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
/* %% [15.0] code to get the start state into yy_current_state goes here */
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
/* %% [16.0] code to find the next state goes here */
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 985 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
/* %if-c-only */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
/* %endif */
/* %if-c++-only */
/* %endif */
{
	register int yy_is_jam;
    /* %% [17.0] code to find the next state, and perhaps do backing up, goes here */
	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 985 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 984);

	return yy_is_jam ? 0 : yy_current_state;
}

/* %if-c-only */

/* %endif */

/* %if-c-only */
#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

/* %endif */
/* %if-c++-only */
/* %endif */
{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

/* %% [19.0] update BOL and yylineno */
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');

	return c;
}
/* %if-c-only */
#endif	/* ifndef YY_NO_INPUT */
/* %endif */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
/* %if-c-only */
    void yyrestart  (FILE * input_file )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
/* %if-c-only */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

/* %if-c-only */
static void yy_load_buffer_state  (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
/* %if-c-only */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
/* %endif */
/* %if-c++-only */
/* %endif */
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
/* %if-c-only */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

/* %if-c-only */

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* %endif */

/* %if-c++-only */
/* %endif */

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
/* %if-c-only */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )
/* %endif */
/* %if-c++-only */
/* %endif */

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

/* %if-c-only */

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
/* %endif */
/* %if-c++-only */
/* %endif */
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
/* %if-c-only */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/* %if-c-or-c++ */
/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
/* %if-c-only */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}
/* %endif */

/* %if-c-or-c++ */
/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
/* %if-c-only */
void yypop_buffer_state (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}
/* %endif */

/* %if-c-or-c++ */
/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
/* %if-c-only */
static void yyensure_buffer_stack (void)
/* %endif */
/* %if-c++-only */
/* %endif */
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}
/* %endif */

/* %if-c-only */
/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}
/* %endif */

/* %if-c-only */
/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}
/* %endif */

/* %if-c-only */
/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param bytes the byte buffer to scan
 * @param len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}
/* %endif */

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

/* %if-c-only */
static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}
/* %endif */
/* %if-c++-only */
/* %endif */

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/* %if-c-only */
/* %if-reentrant */
/* %endif */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/* %if-reentrant */
/* %endif */

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

/* %endif */

/* %if-reentrant */
/* %if-bison-bridge */
/* %endif */
/* %endif if-c-only */

/* %if-c-only */
static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}
/* %endif */

/* %if-c-only SNIP! this currently causes conflicts with the c++ scanner */
/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

/* %if-reentrant */
/* %endif */
    return 0;
}
/* %endif */

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

/* %if-tables-serialization definitions */
/* %define-yytables   The name for this specific scanner's tables. */
#define YYTABLES_NAME "yytables"
/* %endif */

/* %ok-for-header */

#line 987 "lex.l"



int
yylex()
{
        int rc = lexscan();
	if (rc != T_MODBEG && rc != T_MODEND)
		inctx_flags |= INCTX_HADINPUT;
	return rc;
}

void
init_string_space()
{
        mu_opool_create(&string_pool, MU_OPOOL_ENOMEMABRT);
}

void
free_string_space()
{
	mu_opool_destroy(&string_pool);
}

char *
mf_strdup(const char *str)
{
	string_add(str, strlen(str) + 1);
	return mu_opool_finish(string_pool, NULL);
}

struct literal *
string_alloc(const char *str, size_t len)
{
	string_begin();
	string_add(str, len);
	return string_finish();
}

static void
string(const char *str, size_t len)
{
	yylval.literal = string_alloc(str, len);
}

void
string_begin()
{
	/* nothing */
}

struct literal *
string_finish()
{
	char *ptr;
	struct literal *lit;
	mu_opool_append_char(string_pool, 0);
	ptr = mu_opool_finish(string_pool, NULL);
	lit = literal_lookup(ptr);
	if (lit->text != ptr)
		mu_opool_free(string_pool, ptr);
	return lit;
}

static void
line_finish()
{	
	yylval.literal = string_finish();
	if (yy_flex_debug)
		fprintf(stderr, "constructed line: %s\n",
			yylval.literal->text);
}		

void
string_add(const char *str, size_t len)
{
	mu_opool_append(string_pool, str, len);
}

void
string_add_char(unsigned char c)
{
	mu_opool_append_char(string_pool, c);
}

void
parse_warning(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
        mu_diag_voutput (MU_DIAG_WARNING, fmt, ap);
	va_end(ap);
}

void
parse_warning_locus(struct mu_locus_range const *loc, const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
        mu_vdiag_at_locus_range(MU_DIAG_WARNING, loc, fmt, ap);
	va_end(ap);
}

void
parse_error(const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
        mu_diag_voutput(MU_DIAG_ERROR, fmt, ap);
	va_end(ap);
	error_count++;
}

void
parse_error_locus(struct mu_locus_range const *loc, const char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
        mu_vdiag_at_locus_range(MU_DIAG_ERROR, loc, fmt, ap);
	va_end(ap);
	error_count++;
}



static int
lex_close_source()
{
	if (!yyin)
		return 1;
	if (ext_pp)
 	        pp_extrn_shutdown(yyin, pp_pid);
	else
		fclose(yyin);
	yyin = NULL;
        mu_linetrack_destroy(&trk);
	
	switch (YYSTATE) {
	case INITIAL:
		/* ok */
		break;

	case COMMENT:
                mu_diag_at_locus_point (MU_DIAG_ERROR, &start_locus,
                                        "%s", _("end of file in comment"));
		break;

	case STR:
	case ML:
	case CML:
	case QML:
                mu_diag_at_locus_point (MU_DIAG_ERROR, &start_locus,
		                        "%s", _("end of file in string"));
                break;

	case SHELLMAGIC:
                mu_diag_at_locus_point (MU_DIAG_ERROR, &start_locus,
				        "%s", _("end of file in shell block"));
		break;
	}
	return inctx_pop();
}

void
lex_drain_input()
{
	while (input() != EOF)
		;
}

void
lex_bye()
{
	lex_drain_input();
	lex_close_source();
}

int
yywrap()
{
	if (yy_flex_debug && top_module)
		fprintf(stderr, "--eof in module %s\n", top_module->name);
	if (inctx_flags & INCTX_MODULE)
		emit_token = T_MODEND;
	return lex_close_source();
}

static int
isemptystr(char *text)
{
	for (; *text && mu_isspace (*text); text++)
		;
	return *text == 0;
}

void
tie_in_onblock(int enable)
{
	if (enable)
		BEGIN(ONBLOCK);
	else
		BEGIN(INITIAL);
}

data_type_t
builtin_const_value(const char *s, size_t len, const char **sval, long *nval)
{
	if (strncmp(s, "__file__", len) == 0) {
		struct literal *lit = literal_lookup(yylloc.beg.mu_file);
		*sval = lit->text;
		return dtype_string;
	} else if (strncmp(s, "__line__", len) == 0) {
		*nval = yylloc.beg.mu_line;
		return dtype_number;
	} else if (strncmp(s, "__function__", len) == 0) {
		*sval = function_name();
		return dtype_string;
	} else if (strncmp(s, "__package__", len) == 0) {
		*sval = PACKAGE_TARNAME;
		return dtype_string;
	} else if (strncmp(s, "__version__", len) == 0) {
		*sval = PACKAGE_VERSION;
		return dtype_string;
	} else if (strncmp(s, "__major__", len) == 0) {
		*nval = MAILFROMD_VERSION_MAJOR;
		return dtype_number;
	} else if (strncmp(s, "__minor__", len) == 0) {
		*nval = MAILFROMD_VERSION_MINOR;
		return dtype_number;
	} else if (strncmp(s, "__patch__", len) == 0) {
		*nval = MAILFROMD_VERSION_PATCH;
		return dtype_number;
	} else if (strncmp(s, "__git__", len) == 0) {
#ifdef GIT_DESCRIBE
		*sval = GIT_DESCRIBE;
#else
		*sval = "";
#endif
		return dtype_string;
	} else if (strncmp(s, "__statedir__", len) == 0) {
                *sval = mailfromd_state_dir;
		return dtype_string;
	} else if (strncmp(s, "__defstatedir__", len) == 0) {
		*sval = DEFAULT_STATE_DIR;
		return dtype_string;
	} else if (strncmp(s, "__preproc__", len) == 0) {
		*sval = ext_pp;
		return dtype_string;
	} else if (strncmp(s, "__defpreproc__", len) == 0) {
		*sval = (DEFAULT_PREPROCESSOR) ? DEFAULT_PREPROCESSOR : "";
		return dtype_string;
	} else if (strncmp(s, "__module__", len) == 0) {
		*sval = top_module->dclname ? top_module->dclname : top_module->name;
		return dtype_string;
	}
        return dtype_unspecified;  
}

int
builtin_const(const char *s, size_t len)
{
	const char *sval;
	long nval;
	
	switch (builtin_const_value(s, len, &sval, &nval)) {
	case dtype_number:
		yylval.number = nval;
		return T_NUMBER;

	case dtype_string:
		string(sval, strlen(sval));
		return T_STRING;

	default:
		abort();
	}
	return T_BOGUS;
}

const char *
symbit_to_qualifier(unsigned f)
{
        switch (f) {
	case SYM_PRECIOUS:
		return "precious";
	case SYM_STATIC:
		return "static";
	case SYM_PUBLIC:
		return "public";
	}
	return NULL;
}

/* End of lex.l */

